scala.tools.nsc.Global

# patmat

#### object patmat extends SubComponent with PatternMatching

Linear Supertypes
PatternMatching, MatchOptimization, MatchAnalysis, MatchApproximation, Solving, ScalaLogic, TreeAndTypeAnalysis, Logic, MatchTreeMaking, MatchCodeGen, MatchTranslation, Interface, TreeDSL, Debugging, TypingTransformers, Transform, SubComponent, AnyRef, Any
Content Hierarchy Learn more about scaladoc diagrams
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. patmat
2. PatternMatching
3. MatchOptimization
4. MatchAnalysis
5. MatchApproximation
6. Solving
7. ScalaLogic
8. TreeAndTypeAnalysis
9. Logic
10. MatchTreeMaking
11. MatchCodeGen
12. MatchTranslation
13. Interface
14. TreeDSL
15. Debugging
16. TypingTransformers
17. Transform
18. SubComponent
19. AnyRef
20. Any

1. Hide All
2. Show all

Learn more about member selection
Visibility

1. Public
2. All

### Type Members

1. #### trait CNF extends PropositionalLogic

   Definition Classes
     Solving

2. #### trait CheckableTreeAndTypeAnalysis extends AnyRef

   Definition Classes
     TreeAndTypeAnalysis

3. #### trait CodegenCore extends MatchMonadInterface

   Definition Classes
     MatchCodeGen

4. #### trait CommonSubconditionElimination extends OptimizedCodegen with MatchApproximator

   Definition Classes
     MatchOptimization

5. #### trait MatchAnalyzer extends MatchApproximator

   Definition Classes
     MatchAnalysis

6. #### trait MatchApproximator extends TreeMakers with TreesAndTypesDomain

   Represent a match as a formula in propositional logic that encodes whether the match matches (abstractly: we only consider types)

7. #### trait MatchMonadInterface extends AnyRef

   Interface with user-defined match monad? if there's a `match`in scope, we use this as the match strategy, assuming it conforms to MatchStrategy as defined below:``

8. #### trait MatchOptimizer extends OptimizedCodegen with SwitchEmission with CommonSubconditionElimination

   Definition Classes
     MatchOptimization

9. #### class MatchTransformer extends TypingTransformer

   Definition Classes
     PatternMatching

10. #### trait MatchTranslator extends PatternMatching.TreeMakers

    Definition Classes
      MatchTranslation

11. #### trait OptimizedCodegen extends CodegenCore with TypedSubstitution with OptimizedMatchMonadInterface

    Definition Classes
      MatchCodeGen

12. #### trait OptimizedMatchMonadInterface extends MatchMonadInterface

    Definition Classes
      MatchCodeGen

13. #### class OptimizingMatchTranslator extends MatchTranslator with MatchOptimizer with MatchAnalyzer with Solver

    Definition Classes
      PatternMatching

14. #### class Phase extends StdPhase

    The phase defined by this transform

15. #### trait PropositionalLogic extends AnyRef

    Definition Classes
      Logic

16. #### trait PureCodegen extends CodegenCore with PureMatchMonadInterface

    Definition Classes
      MatchCodeGen

17. #### trait PureMatchMonadInterface extends MatchMonadInterface

    Definition Classes
      MatchCodeGen

18. #### class PureMatchTranslator extends MatchTranslator with PureCodegen

    Definition Classes
      PatternMatching

19. #### trait Solver extends CNF

    Definition Classes
      Solving

20. #### abstract class StdPhase extends GlobalPhase

    A standard phase template

21. #### final case class Suppression (exhaustive: Boolean, unreachable: Boolean) extends Product with Serializable

    Definition Classes
      MatchTreeMaking

22. #### trait SwitchEmission extends TreeMakers with OptimizedMatchMonadInterface

    Definition Classes
      MatchOptimization

23. #### trait TreeMakers extends TypedSubstitution with CodegenCore

    Definition Classes
      MatchTreeMaking

24. #### trait TreesAndTypesDomain extends PropositionalLogic with CheckableTreeAndTypeAnalysis

    Definition Classes
      ScalaLogic

25. #### trait TypedSubstitution extends MatchMonadInterface

    Definition Classes
      Interface

26. #### abstract class TypingTransformer extends Global.Transformer

    Definition Classes
      TypingTransformers

### Value Members

1. #### final def !=(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

2. #### final def !=(arg0: Any): Boolean

   Definition Classes
     Any

3. #### final def ##(): Int

   Definition Classes
     AnyRef → Any

4. #### final def ==(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

5. #### final def ==(arg0: Any): Boolean

   Definition Classes
     Any

6. #### object CODE

   Definition Classes
     TreeDSL

7. #### object Suppression extends Serializable

   Definition Classes
     MatchTreeMaking

8. #### final def afterOwnPhase[T](op: ⇒ T): T

   Definition Classes
     SubComponent
   Annotations
     @inline()

9. #### def alignAcrossRows(xss: List[List[AnyRef]], sep: String, lineSep: String = "\n"): String

   Definition Classes
     Logic

10. #### final def asInstanceOf[T0]: T0

    Definition Classes
      Any

11. #### final def beforeOwnPhase[T](op: ⇒ T): T

    Definition Classes
      SubComponent
    Annotations
      @inline()

12. #### def clone(): AnyRef

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

13. #### final def dealiasWiden(tp: Global.Type): Global.Type

    Attributes
      protected
    Definition Classes
      Interface

14. #### object debug

    Definition Classes
      Debugging

15. #### final def devWarning(str: String): Unit

    Attributes
      protected
    Definition Classes
      Interface

16. #### final def eq(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

17. #### def equals(arg0: Any): Boolean

    Definition Classes
      AnyRef → Any

18. #### def finalize(): Unit

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )

19. #### final def getClass(): Class[_]

    Definition Classes
      AnyRef → Any

20. #### val global: Global.this.type

    The global environment; overridden by instantiation in Global.

    The global environment; overridden by instantiation in Global.

    Definition Classes
      patmat → TreeDSL → Debugging → TypingTransformers → SubComponent

21. #### final def hasStableSymbol(p: Global.Tree): Boolean

    Attributes
      protected
    Definition Classes
      Interface

22. #### def hashCode(): Int

    SubComponent are added to a HashSet and two phases are the same if they have the same name

    SubComponent are added to a HashSet and two phases are the same if they have the same name

    Definition Classes
      SubComponent → AnyRef → Any

23. #### def instanceOfTpImplies(tp: Global.Type, tpImplied: Global.Type): Boolean

    Definition Classes
      TreeAndTypeAnalysis

24. #### val internal: Boolean

    Internal flag to tell external from internal phases

    Internal flag to tell external from internal phases

    Definition Classes
      SubComponent

25. #### final def isInstanceOf[T0]: Boolean

    Definition Classes
      Any

26. #### final def mkFALSE: Global.Literal

    Attributes
      protected
    Definition Classes
      Interface

27. #### final def mkTRUE: Global.Literal

    Attributes
      protected
    Definition Classes
      Interface

28. #### final def ne(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

29. #### def newPhase(prev: nsc.Phase): StdPhase

    Create a new phase which applies transformer

    Create a new phase which applies transformer

    Definition Classes
      Transform → SubComponent

30. #### def newTransformer(unit: Global.CompilationUnit): Global.Transformer

    The transformer factory

    The transformer factory

    Definition Classes
      PatternMatching → Transform

31. #### final def notify(): Unit

    Definition Classes
      AnyRef

32. #### final def notifyAll(): Unit

    Definition Classes
      AnyRef

33. #### def ownPhase: nsc.Phase

    The phase corresponding to this subcomponent in the current compiler run

    The phase corresponding to this subcomponent in the current compiler run

    Definition Classes
      SubComponent

34. #### val phaseName: String

    The name of the phase

    The name of the phase

    Definition Classes
      PatternMatching → SubComponent

35. #### def phaseNewFlags: Long

    New flags defined by the phase which are not valid before

    New flags defined by the phase which are not valid before

    Definition Classes
      SubComponent

36. #### def phaseNextFlags: Long

    New flags defined by the phase which are not valid until immediately after it

    New flags defined by the phase which are not valid until immediately after it

    Definition Classes
      SubComponent

37. #### val runsAfter: collection.immutable.List[String]

    List of phase names, this phase should run after

    List of phase names, this phase should run after

    Definition Classes
      patmat → SubComponent

38. #### val runsBefore: List[String]

    List of phase names, this phase should run before

    List of phase names, this phase should run before

    Definition Classes
      SubComponent

39. #### val runsRightAfter: None.type

    Phase name this phase will attach itself to, not allowing any phase to come between it and the phase name declared

    Phase name this phase will attach itself to, not allowing any phase to come between it and the phase name declared

    Definition Classes
      patmat → SubComponent

40. #### def sameValue(a: Global.Tree, b: Global.Tree): Boolean

    Definition Classes
      TreeAndTypeAnalysis

41. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

42. #### def toString(): String

    Definition Classes
      AnyRef → Any

43. #### object vpmName

    Definition Classes
      Interface

44. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

45. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

46. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

### Inherited from PatternMatching

### Inherited from MatchOptimization

### Inherited from MatchAnalysis

### Inherited from MatchApproximation

### Inherited from Solving

### Inherited from ScalaLogic

### Inherited from TreeAndTypeAnalysis

### Inherited from Logic

### Inherited from MatchTreeMaking

### Inherited from MatchCodeGen

### Inherited from MatchTranslation

### Inherited from Interface

### Inherited from TreeDSL

### Inherited from Debugging

### Inherited from TypingTransformers

### Inherited from Transform

### Inherited from SubComponent

### Inherited from AnyRef

### Inherited from Any

### Ungrouped